-- Create test data.
-- Caution: This script deletes all existing data.
-- Note: Sequence tables are created starting at 101.

DELETE FROM address;
DELETE FROM groups;
DELETE FROM medrec_user;
DELETE FROM patient;
DELETE FROM physician;
DELETE FROM prescription;
DELETE FROM record;
DELETE FROM vital_signs;

-- Address
INSERT INTO address (id,street1,street2,city,state,zip,country) VALUES (101,'1224 Post St','Suite 100','San Francisco','CA','94115','United States');
INSERT INTO address (id,street1,street2,city,state,zip,country) VALUES (102,'235 Montgomery St','Suite 15','Ponte Verde','FL','32301','United States');
INSERT INTO address (id,street1,street2,city,state,zip,country) VALUES (103,'1234 Market','','San Diego','CA','92126','United States');

-- Groups
INSERT INTO groups (username,group_name) VALUES ('fred@golf.com','MedRecPatients');
INSERT INTO groups (username,group_name) VALUES ('larry@bball.com','MedRecPatients');
INSERT INTO groups (username,group_name) VALUES ('charlie@star.com','MedRecPatients');
INSERT INTO groups (username,group_name) VALUES ('volley@ball.com','MedRecPatients');
INSERT INTO groups (username,group_name) VALUES ('page@fish.com','MedRecPatients');

-- Patient
INSERT INTO patient (id,first_name,middle_name,last_name,dob,gender,ssn,address_id,phone,email) VALUES (101,'Fred','I','Winner','1965-03-26','Male','123456789',101,'4151234564','fred@golf.com');
INSERT INTO patient (id,first_name,middle_name,last_name,dob,gender,ssn,address_id,phone,email) VALUES (102 ,'Larry','J','Parrot','1959-02-13','Male','777777777',101,'4151234564','larry@bball.com');
INSERT INTO patient (id,first_name,middle_name,last_name,dob,gender,ssn,address_id,phone,email) VALUES (103 ,'Charlie','E','Florida','1973-10-29','Male','444444444',102,'4151234564','charlie@star.com');
INSERT INTO patient (id,first_name,middle_name,last_name,dob,gender,ssn,address_id,phone,email) VALUES (104 ,'Gabrielle','H','Spiker','1971-08-17','Female','333333333',101,'4151234564','volley@ball.com');
INSERT INTO patient (id,first_name,middle_name,last_name,dob,gender,ssn,address_id,phone,email) VALUES (105 ,'Page','A','Trout','1972-02-18','Male','888888888',102,'4151234564','page@fish.com');

-- Physician
INSERT INTO physician (id,first_name,middle_name,last_name,phone,email) VALUES (101,'Mary','J','Oblige','1234567812','mary@md.com');
INSERT INTO physician (id,first_name,middle_name,last_name,phone,email) VALUES (102 ,'Phil','B','Lance','1234567812','phil@syscon.com');
INSERT INTO physician (id,first_name,middle_name,last_name,phone,email) VALUES (103 ,'Kathy','E','Wilson','1234567812','kwilson@dr.com');

-- Record
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (101,101,102,'1999-06-18',101,'Complains about chest pain.','Mild stroke.  Aspirin advised.','Patient needs to stop smoking.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (102,101,103,'1993-05-30',101,'Sneezing, coughing, stuffy head.','Common cold. Prescribed codiene cough syrup.','Call back if not better in 10 days.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (103,101,102,'1989-07-05',101,'Twisted knee while playing soccer.','Severely sprained interior ligament.  Surgery required.','Cast will be necessary before and after.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (104,103,103,'2000-02-18',102,'Exhaustion and extreme fatigue.','Mononucleosis.','Notes start here.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (105,105,101,'1991-04-01',103,'Drowsy all day.','Allergic to coffee.  Drink tea.','No notes.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (106,105,102,'1987-01-13',101,'Blurred vision.','Increased loss of vision due to recent car accident.','Admit patient to hospital.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (107,105,101,'1990-09-09',102,'Sore throat.','Strep thoart culture taken.  Sleep needed.','Call if positive.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (108,102,102,'2001-06-20',101,'Overjoyed with everything.','Patient is crazy.  Recommend politics.','');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (109,104,103,'2002-11-03',101,'Sprained ankle.','Lite cast needed.','At least 20 sprained ankles since 15.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (110,103,103,'1997-12-21',101,'Forgetful, short-term memory not as sharpe.','General old age.','Patient will someday be 120 years old.');
INSERT INTO record (id,pat_id,phys_id,record_date,vital_id,symptoms,diagnosis,notes) VALUES (111,104,102,'2001-05-13',102,'Nothing is wrong.','This gal is fine.','Patient likes lobby magazines.');

-- Prescription
INSERT INTO prescription (id,pat_id,date_prescribed,drug,record_id,dosage,frequency,refills_remaining,instructions) VALUES (101,101,'1999-06-18','Advil',101,'100 tbls','1/4hrs',0,'No instructions');
INSERT INTO prescription (id,pat_id,date_prescribed,drug,record_id,dosage,frequency,refills_remaining,instructions) VALUES (102,101,'1999-06-18','Drixoral',101,'16 oz','1tspn/4hrs',0,'No instructions');
INSERT INTO prescription (id,pat_id,date_prescribed,drug,record_id,dosage,frequency,refills_remaining,instructions) VALUES (103,101,'1993-05-30','Codeine',102,'10 oz','1/6hrs',1,'No instructions');
INSERT INTO prescription (id,pat_id,date_prescribed,drug,record_id,dosage,frequency,refills_remaining,instructions) VALUES (104,102,'2001-06-20','Valium',108,'50 pills','1/day',3,'No instructions');

-- User
INSERT INTO medrec_user (username,password,status) VALUES ('volley@ball.com','{sha-1}JWMxUEYXBrFqQHTydHo9cnpAJ/Gq8QY=','ACTIVE');
INSERT INTO medrec_user (username,password,status) VALUES ('page@fish.com','{sha-1}JWMxUEYXBrFqQHTydHo9cnpAJ/Gq8QY=','ACTIVE');
INSERT INTO medrec_user (username,password,status) VALUES ('charlie@star.com','{sha-1}JWMxUEYXBrFqQHTydHo9cnpAJ/Gq8QY=','NEW');
INSERT INTO medrec_user (username,password,status) VALUES ('fred@golf.com','{sha-1}JWMxUEYXBrFqQHTydHo9cnpAJ/Gq8QY=','ACTIVE');
INSERT INTO medrec_user (username,password,status) VALUES ('larry@bball.com','{sha-1}JWMxUEYXBrFqQHTydHo9cnpAJ/Gq8QY=','ACTIVE');

-- Vital Signs
INSERT INTO vital_signs (id,temperature,blood_pressure,pulse,weight,height) VALUES (101,'98','125/85','75',180,70);
INSERT INTO vital_signs (id,temperature,blood_pressure,pulse,weight,height) VALUES (102,'100','120/80','85',199,69);
INSERT INTO vital_signs (id,temperature,blood_pressure,pulse,weight,height) VALUES (103,'98','110/75','95',300,76);

COMMIT;