package com.bea.medrec.domain;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Version;

import com.bea.medrec.utils.MedRecUtils;

/**
 * <p>
 * This class represents information about an address.
 * </p>
 * 
 * @author Copyright (c)
 * @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */

/*
 * Declare that this class can be persisted. The container will access the
 * fields of the class directly when it needs to read or write persistent
 * values.
 */
@Entity()
public class Address implements Serializable {

    @Id()
    @GeneratedValue(strategy = IDENTITY)
    private Integer id;

    @Version
    @Column(name="version")
    private Integer version;
    
    private String city;

    private String country;

    private String state;

    private String street1;

    private String street2;

    private String zip;

    public Address() {
    }

    public Integer getId() {
        return this.id;
    }

    public void setId(Integer pId) {
        this.id = pId;
    }

    public void setId(String pId) {
        this.id = MedRecUtils.str2Integer(pId);
    }

    public String getCity() {
        return this.city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getCountry() {
        return this.country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public String getState() {
        return this.state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getStreet1() {
        return this.street1;
    }

    public void setStreet1(String street1) {
        if (street1 == null)
            street1 = "";
        this.street1 = street1;
    }

    public String getStreet2() {
        return this.street2;
    }

    public void setStreet2(String street2) {

        if (street2 == null)
            street2 = "";
        this.street2 = street2;
    }

    public String getZip() {
        return this.zip;
    }

    public void setZip(String zip) {
        this.zip = zip;
    }

    // Utility
    public String toString() {
        StringBuffer str = new StringBuffer();
        str.append("Address[Id: " + getId());
        str.append(" | Street1: " + street1);
        str.append(" | Street2: " + street2);
        str.append(" | City: " + city);
        str.append(" | State: " + state);
        str.append(" | ZipCode: " + zip);
        str.append(" | Country: " + country);
        str.append("]");
        return str.toString();
    }
}
