package com.bea.medrec.domain;

import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.EqualsBuilder;
import com.bea.medrec.domain.User;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Column;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.Table;
import javax.persistence.Version;

/*
 * Declare that this class is a JPA entity.  The container will access
 * the fields of the class directly when it needs to read or write 
 * persistent values.
 */
@Entity()

/*
 * Declare a class that represents the primary key for this entity.  This
 * is needed since Group uses a compound primary key.
 */
@IdClass(GroupPK.class)

/*
 * Declare the database table to which this class is mapped.
 */
@Table(name = "groups")

public class Group implements Serializable
{

  @Id
  @Column(name = "group_name")
  private String groupName;

  @Id
  private String userName;

  @Version
  @Column(name="version")
  private Integer version;
  
  /** full constructor */
  public Group(GroupPK id)
  {
    this.groupName = id.getGroupName();
    this.userName = id.getUserName();
  }

  /** default constructor */
  public Group()
  {
  }

  public GroupPK getid()
  {
    return new GroupPK(groupName, userName);
  }

  public void setid(GroupPK id)
  {
    groupName = id.getGroupName();
    userName = id.getUserName();
  }

  public String toString()
  {
    return new ToStringBuilder(this).append("groupName", groupName).append(
        "userName", userName).toString();
  }

  public boolean equals(Object other)
  {
    if ((this == other))
      return true;
    if (!(other instanceof Group))
      return false;
    Group castOther = (Group) other;

    return new EqualsBuilder().append(groupName, castOther.groupName).append(
        userName, castOther.userName).isEquals();
  }

  public int hashCode()
  {
    return new HashCodeBuilder().append(groupName).append(userName)
        .toHashCode();
  }

  public String getGroupName()
  {
    return groupName;
  }

  public void setGroupName(String groupName)
  {
    this.groupName = groupName;
  }

  public String getUserName()
  {
    return userName;
  }

  public void setUserName(String userName)
  {
    this.userName = userName;
  }
}
