package com.bea.medrec.domain;

import java.io.Serializable;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

public class GroupPK implements Serializable {

    /** identifier field */
    public String groupName;

    /** identifier field */
    public String userName;

    /** full constructor */
    public GroupPK(String groupName, String userName) {
        this.groupName = groupName;
        this.userName = userName;
    }

    /** default constructor */
    public GroupPK() {
    }

    public GroupPK(String stringForm){
      int groupStart=stringForm.indexOf ("groupName=")+"groupName".length();
      int groupEnd=stringForm.indexOf(",");
      this.groupName=stringForm.substring(groupStart, groupEnd);
      
      int userStart=stringForm.indexOf ("userName=")+"userName".length();
      int userEnd=stringForm.indexOf("]");
      this.userName=stringForm.substring(userStart, userEnd);
    }
    
    public String getGroupName() {
        return this.groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public String getUserName() {
        return this.userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("groupName", getGroupName())
            .append("userName", getUserName())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof GroupPK) ) return false;
        GroupPK castOther = (GroupPK) other;
        return new EqualsBuilder()
            .append(this.getGroupName(), castOther.getGroupName())
            .append(this.getUserName(), castOther.getUserName())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getGroupName())
            .append(getUserName())
            .toHashCode();
    }

    public static void main (String [] args) {
      
      GroupPK one=new GroupPK("group1", "user1");
      String stringForm=one.toString();
      
      GroupPK two=new GroupPK(stringForm);
      assert (one.equals(two));
      
      GroupPK three=new GroupPK("group2", "user2");
      assert (!three.equals(one));
    }
}
