package com.bea.medrec.domain;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Version;

/**
 * <p>This class represents information about a patient.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */

/*
 * Declare that this class is a JPA entity.  The container will access
 * the fields of the class directly when it needs to read or write 
 * persistent values.
 */
@Entity()

public class Physician implements Serializable{

  @Id()
  @GeneratedValue(strategy=IDENTITY)
  private Integer id;

  @Version
  @Column(name="version")
  private Integer version;
  
  private String email;

  @Column(name="first_name")
  private String firstName;

  @Column(name="last_name")
  private String lastName;

  @Column(name="middle_name")
  private String middleName;

  private String phone;

  public Physician() {
  }

  public Integer getId() {
    return this.id;
  }

  public void setId(Integer pId) {
    this.id = pId;
  }

  public String getEmail() {
    return this.email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public String getFirstName() {
    return this.firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public String getLastName() {
    return this.lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public String getMiddleName() {
    return this.middleName;
  }

  public String getName() {
    return this.firstName+" "+this.middleName+" "+this.lastName;
  }

  public void setMiddleName(String middleName) {
    this.middleName = middleName;
  }

  public String getPhone() {
    return this.phone;
  }

  public void setPhone(String phone) {
    this.phone = phone;
  }

  public String toString() {
    StringBuffer str = new StringBuffer();
    str.append("PHYSICIAN [Id: "+id);
    str.append("| Name: "+firstName);
    str.append(" "+middleName);
    str.append(" "+lastName);
    str.append("| Phone: "+phone);
    str.append("| Email: "+email);
    str.append("]");
    return str.toString();
  }
}
