package com.bea.medrec.domain;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Version;

/**
 * <p>
 * This class represents a patient's vital signs.
 * </p>
 * 
 * @author Copyright (c)
 * @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */

/*
 * Declare that this class is a JPA entity. The container will use property
 * access methods (getXxx, setXxx) to read or write persistent values (the
 * default).
 */
@Entity

/*
 * Declare the database table to which this class is mapped.
 */
@Table(name = "vital_signs")

public class VitalSigns implements Serializable {

    private Integer id;

    private Integer version;
    
    private String bloodPressure;

    private Integer height;

    private String pulse;

    private String temperature;

    private Integer weight;

    public VitalSigns() {
    }

    @Id()
    @GeneratedValue(strategy = IDENTITY)
    public Integer getId() {
        return this.id;
    }

    public void setId(Integer pId) {
        this.id = pId;
    }

    @Version
    @Column(name="version")
    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    @Column(name = "blood_pressure")
    public String getBloodPressure() {
        return this.bloodPressure;
    }

    public void setBloodPressure(String bloodPressure) {
        this.bloodPressure = bloodPressure;
    }

    public Integer getHeight() {
        return this.height;
    }

    public void setHeight(Integer height) {
        this.height = height;
    }

    public String getPulse() {
        return this.pulse;
    }

    public void setPulse(String pulse) {
        this.pulse = pulse;
    }

    public String getTemperature() {
        return this.temperature;
    }

    public void setTemperature(String temperature) {
        this.temperature = temperature;
    }

    public Integer getWeight() {
        return this.weight;
    }

    public void setWeight(Integer weight) {
        this.weight = weight;
    }

    public String toString() {
        StringBuffer str = new StringBuffer();
        str.append("VITALSIGNS [Id: ").append(id);
        str.append(" | Temp: ").append(temperature);
        str.append(" | BP: ").append(bloodPressure);
        str.append(" | Pulse: ").append(pulse);
        str.append(" | Weight: ").append(weight);
        str.append(" | Height: ").append(height);
        str.append("]");

        return str.toString();
    }
}
