package com.bea.medrec.utils;

import java.util.Hashtable;

import javax.naming.Binding;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingEnumeration;
import javax.persistence.EntityManagerFactory;

import kodo.persistence.KodoPersistence;

import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.InitializingBean;

public class KodoEntityManagerFactoryBean implements FactoryBean, InitializingBean {
    private String jndiName = "kodo-jpa";

    private EntityManagerFactory entityManagerFactory = null;

    public void setJndiName(String jndiName) {
        this.jndiName = jndiName;
    }

    public Object getObject() throws Exception {
        // TODO Auto-generated method stub
        return entityManagerFactory;
    }

    public Class getObjectType() {
        return EntityManagerFactory.class;
    }

    public boolean isSingleton() {
        return true;
    }

    public void afterPropertiesSet() throws Exception {
        try {
            entityManagerFactory = KodoPersistence.createEntityManagerFactory(jndiName, new InitialContext());
        } catch (Throwable throwable) {
            throw new RuntimeException(throwable);
        }
    }
}
