package com.bea.medrec.dao.orm;

import com.bea.medrec.dao.UserDao;
import com.bea.medrec.domain.User;
import com.bea.medrec.domain.Patient;
import com.bea.medrec.utils.MedRecLog4jFactory;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.List;
import javax.sql.DataSource;
import org.apache.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.SqlParameter;
import org.springframework.jdbc.object.MappingSqlQuery;
import org.springframework.jdbc.object.SqlUpdate;

/**
 * FIXME
 */
public class JpaUserDao
    extends BaseDao implements UserDao {

  private static Logger logger =
    MedRecLog4jFactory.getLogger(JpaUserDao.class.getName());

  public User getByUsername(String pUsername) throws DataAccessException {
    return (User)getJpaTemplate().find(User.class, pUsername);
  }

  public String getPassword(String pUsername) throws DataAccessException {
    List passwords = getJpaTemplate().find(
        "SELECT password "+
        "FROM "+User.class.getName()+" "+
        "WHERE username=?1", pUsername);
    
    return (passwords.isEmpty()) ? null : (String)passwords.get(0);
  }

  public void updateStatus(User pUser) throws DataAccessException {
    save (pUser);
  }

  public void save(User pUser) throws DataAccessException {
    getJpaTemplate().merge(pUser);
  }
}
