package com.bea.medrec.service;

import com.bea.medrec.domain.MedicalRecord;
import com.bea.medrec.domain.Patient;
import com.bea.medrec.domain.Registration;
import com.bea.medrec.domain.User;
import com.bea.medrec.exceptions.MedRecException;
import java.io.File;
import java.util.List;
import weblogic.diagnostics.accessor.ColumnInfo;
import weblogic.management.runtime.WLDFAccessRuntimeMBean;

/**
 * <p>Service interface for all functionality related to adminstration management.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public interface AdminService {

  public void activateAccount(User pUser)
      throws MedRecException;

  public void saveAdminUser(User pUser) throws MedRecException;

  public void savePatientUser(Patient pPatient, User pUser)
      throws MedRecException;

  public Integer createPatientAccount(User pUser, Patient pPatient)
      throws MedRecException;

  public Patient createPatientAccount(Patient pPatient)
      throws MedRecException;

  public void denyAccountStatus(User pUser)
      throws MedRecException;

  public ColumnInfo[] getLogColumnInfo(String pLogType)
      throws MedRecException;

  public Object[] getLogRows(String pLogType, String pQueryStr)
      throws MedRecException;

  public String[] getLogTypes() throws MedRecException;

  public List getNewPatients() throws MedRecException;

  public User getUser(User pUser) throws MedRecException;

  public WLDFAccessRuntimeMBean getDiagntosicMBean() throws MedRecException;

  public void saveMedicalRecord(List<MedicalRecord> pMedRecCol)
    throws MedRecException;

  public void saveRegistration(Registration pReg) throws MedRecException;

  public void processPatientRecordUpload(File pUploadFile) throws MedRecException;

  public void updateAccountStatus(User pUser)
      throws MedRecException;
}