package com.bea.medrec.service;

import com.bea.medrec.domain.*;
import com.bea.medrec.exceptions.MedRecException;
import java.io.File;
import java.util.List;
import java.util.Collection;
import weblogic.diagnostics.accessor.ColumnInfo;

/**
 * FIXME
 */
public interface MedRecClientServiceFacade {

  // admin service
  public void activateAccount(User pUser) throws MedRecException;

  public void saveAdminUser(User pUser) throws MedRecException;

  public Patient authenticate(User pUser) throws MedRecException;

  public void denyAccountStatus(User pUser) throws MedRecException;

  public ColumnInfo[] getLogColumnInfo(String pLogType)
      throws MedRecException;

  public Object[] getLogRows(String pLogType, String pQueryStr)
      throws MedRecException;

  public String[] getLogTypes() throws MedRecException;

  public List getNewPatients() throws MedRecException;

  public void processPatientRecordUpload(File pUploadFile)
      throws MedRecException;

  public void saveRegistration(Registration pRegistration)
      throws MedRecException;

  // patient service
  public Patient getPatient(Patient pPatient) throws MedRecException;

  public Patient savePatient(Patient pPatient) throws MedRecException;

  public Patient updatePatient (Patient patient)throws MedRecException;
  
  // record service
  public Record getRecord(Integer pRecordId) throws MedRecException;

  public RecordsSummary getRecordsSummary(Patient pPatient)
      throws MedRecException;

  public Collection<Object> getIncomingXmlFiles() throws MedRecException;
}
