package com.bea.medrec.service;

import com.bea.medrec.domain.*;
import com.bea.medrec.exceptions.MedRecException;
import java.io.File;
import java.util.List;
import java.util.Collection;
import weblogic.diagnostics.accessor.ColumnInfo;

/**
 * FIXME
 */
public class MedRecClientServiceFacadeImpl
    implements MedRecClientServiceFacade {

  protected AdminService adminService;
  protected PatientService patientService;
  protected RecordService recordService;
  protected RecordXmlProcessorService recordXmlProcessorService;

  // setters
  /**
   * <p>Sets AdminService.<p>
   */
  public void setAdminService(AdminService adminService) {
    this.adminService = adminService;
  }

 /**
  * <p>Sets PatientService.<p>
  */
  public void setPatientService(PatientService patientService) {
    this.patientService = patientService;
  }

 /**
  * <p>Sets RecordService.<p>
  */
  public void setRecordService(RecordService recordService) {
    this.recordService = recordService;
  }

  public void setRecordXmlProcessorService(
      RecordXmlProcessorService pRecordXmlProcessorService) {
    this.recordXmlProcessorService = pRecordXmlProcessorService;
  }

  // business methods
  // admin service
  public void activateAccount(User pUser) throws MedRecException {
    adminService.activateAccount(pUser);
  }

  public void saveAdminUser(User pUser) throws MedRecException {
    adminService.saveAdminUser(pUser);
  }

  public Patient authenticate(User pUser) throws MedRecException {
    return patientService.authenticate(pUser);
  }

  public void denyAccountStatus(User pUser) throws MedRecException {
    adminService.denyAccountStatus(pUser);
  }

  public ColumnInfo[] getLogColumnInfo(String pLogType)
      throws MedRecException {
    return adminService.getLogColumnInfo(pLogType);
  }

  public Object[] getLogRows(String pLogType, String pQueryStr)
      throws MedRecException {
    return adminService.getLogRows(pLogType, pQueryStr);
  }

  public String[] getLogTypes() throws MedRecException {
    return adminService.getLogTypes();
  }

  public List getNewPatients() throws MedRecException {
    return adminService.getNewPatients();
  }

  public void processPatientRecordUpload(File pUploadFile)
      throws MedRecException {
    adminService.processPatientRecordUpload(pUploadFile);
  }

  public void saveRegistration(Registration pRegistration)
      throws MedRecException {
    adminService.saveRegistration(pRegistration);
  }

  // patient service
  public Patient getPatient(Patient pPatient) throws MedRecException {
    return patientService.getPatient(pPatient);
  }

  public Patient savePatient(Patient pPatient) throws MedRecException {
    return patientService.savePatient(pPatient);
  }
  
  public Patient updatePatient(Patient pPatient) throws MedRecException {
    return patientService.updatePatient(pPatient);
  }

  // record service
  public Record getRecord(Integer pRecordId) throws MedRecException {
    return recordService.getRecord(pRecordId);
  }

  public RecordsSummary getRecordsSummary(Patient pPatient)
      throws MedRecException {
    return recordService.getRecordsSummary(pPatient);
  }

  // record upload
  public Collection<Object> getIncomingXmlFiles() throws MedRecException {
    return recordXmlProcessorService.getIncomingXmlFiles();
  }

}
