package com.bea.medrec.service;

import com.bea.medrec.domain.*;
import com.bea.medrec.exceptions.MedRecException;
import java.io.File;
import java.util.List;
import org.springframework.mail.SimpleMailMessage;

/**
 * FIXME
 */
public interface MedRecServiceFacade {
  // business methods
  // admin service
  public Integer createPatientAccount(User pUser, Patient pPatient)
      throws MedRecException;

  public Patient createPatientAccount(Patient pPatient)
      throws MedRecException;

  public void saveMedicalRecord(List<MedicalRecord> pMedicalRecords)
      throws MedRecException;

  // mail service
  public void sendMail(SimpleMailMessage pMail) throws MedRecException;

  public void composeAndSendMail(Mail pMail)
      throws MedRecException;

  // messaging service
  public void sendToQueue(SimpleMailMessage pMail) throws MedRecException;

  public void sendToQueue(Registration pRegistration) throws MedRecException;

  public void sendToQueue(File pUploadFile) throws MedRecException;

  // patient service
  public Patient getPatient(Patient pPatient) throws MedRecException;

  public List getPatientByWildLastName(Patient pPatient) throws MedRecException;

  public void processNewRegistration(Registration pReg)
      throws MedRecException;

  public Patient savePatient(Patient pPatient) throws MedRecException;

  // record service
  public Record getRecord(Integer pRecordId) throws MedRecException;

  public RecordsSummary getRecordsSummary(Patient pPatient)
      throws MedRecException;

  public Record saveRecord(Record pRecord) throws MedRecException;

  public void saveRecords(List pRecord, Patient pPatient)
      throws MedRecException;

  // record upload
  public void saveXmlRecord(String pFilename) throws MedRecException;
}
