package com.bea.medrec.service;

import com.bea.medrec.domain.Registration;
import com.bea.medrec.exceptions.MedRecException;
import com.bea.medrec.utils.MedRecLog4jFactory;
import java.io.File;
import org.apache.log4j.Logger;
import org.springframework.jms.JmsException;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.mail.SimpleMailMessage;

/**
 * FIXME
 */
public class MessagingServiceImpl
    implements MessagingService {

private static Logger logger =
    MedRecLog4jFactory.getLogger(MessagingServiceImpl.class.getName());

  private JmsTemplate mailJmsTemplate;
  private JmsTemplate registrationJmsTemplate;
  private JmsTemplate uploadJmsTemplate;

  public void setMailJmsTemplate(JmsTemplate mailJmsTemplate) {
    this.mailJmsTemplate = mailJmsTemplate;
  }

  public void setRegistrationJmsTemplate(JmsTemplate registrationJmsTemplate) {
    this.registrationJmsTemplate = registrationJmsTemplate;
  }

  public void setUploadJmsTemplate(JmsTemplate uploadJmsTemplate) {
    this.uploadJmsTemplate = uploadJmsTemplate;
  }

  public void sendToQueue(SimpleMailMessage pMail) throws MedRecException {
    try {
      mailJmsTemplate.convertAndSend(pMail);
    } catch (JmsException e) {
      logger.error("Exception occurred: "+e.getMessage(), e);
      throw new MedRecException("Unable to send mail to queue: "+
          e.getMessage(), e);
    }
  }

  public void sendToQueue(Registration pRegistration) throws MedRecException {
    try {
      registrationJmsTemplate.convertAndSend(pRegistration);
    } catch (JmsException e) {
      logger.error("Exception occurred: "+e.getMessage(), e);
      throw new MedRecException("Unable to send registration to queue: "+
          e.getMessage(), e);
    }
  }

  public void sendToQueue(File pUploadFile) throws MedRecException {
    try {
      uploadJmsTemplate.convertAndSend(pUploadFile);
    } catch (JmsException e) {
      logger.error("Exception occurred: "+e.getMessage(), e);
      throw new MedRecException("Unable to send file to upload queue: "+
          e.getMessage(), e);
    }
  }
}
