package com.bea.medrec.service;

import com.bea.medrec.domain.Patient;
import com.bea.medrec.domain.Registration;
import com.bea.medrec.domain.User;
import com.bea.medrec.exceptions.MedRecException;
import java.util.List;

/**
 * <p>
 * Service interface for all functionality related to patient management.
 * </p>
 * 
 * @author Copyright (c)
 * @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public interface PatientService {

    public Patient authenticate(User user) throws MedRecException;

    public List getPatients(Patient patient) throws MedRecException;

    public Patient getPatient(Patient patient) throws MedRecException;

    public List getPatientByWildLastName(Patient patient) throws MedRecException;

    public void processNewRegistration(Registration pReg) throws MedRecException;

    public void processRegistration(Registration registration) throws MedRecException;

    public Patient savePatient(Patient pPatient) throws MedRecException;

    public Patient updatePatient(Patient pPatient) throws MedRecException;
}