package com.bea.medrec.service;

import com.bea.medrec.domain.Patient;
import com.bea.medrec.domain.Record;
import com.bea.medrec.domain.RecordsSummary;
import com.bea.medrec.exceptions.MedRecException;
import java.util.List;

/**
 * <p>Service interface for all functionality related to record management.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public interface RecordService {
  
  public Record saveRecord(Record pRecord) throws MedRecException;

  public void saveRecords(List pRecords)
      throws MedRecException;

  public void saveRecords(List pRecords, Patient pPatient)
      throws MedRecException;
      
  public List getPrescriptions(Patient pPatient)
      throws MedRecException;

  public List getRecords(Patient pPatient)
      throws MedRecException;

  public Record getRecord(Integer pRecordId) throws MedRecException;

  public RecordsSummary getRecordsSummary(Patient pPatient)
      throws MedRecException;
}