package com.bea.medrec.web.admin.actions;

import com.bea.medrec.exceptions.MedRecException;
import com.bea.medrec.utils.MedRecLog4jFactory;
import com.bea.medrec.web.admin.beans.CreateAdminBean;
import com.bea.medrec.web.exceptions.ClientException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * <p>Action class encapsulating creating new admin functionality.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class CreateNewAdminAction extends AdminBaseLookupDispatchAction {

  private static Logger logger =
          MedRecLog4jFactory.getLogger(CreateNewAdminAction.class.getName());

  public ActionForward execute(ActionMapping mapping,
                               ActionForm form,
                               HttpServletRequest request,
                               HttpServletResponse response)
          throws ClientException, Exception {
    logger.debug("method mapping=" +
            request.getParameter(mapping.getParameter()));
    if (request.getParameter(mapping.getParameter()) == null) {
      return defaultMethod(mapping, form, request, response);
    } else
      return super.execute(mapping, form, request, response);
  }

  /**
   * <p>Determines method calling based on select submit button.</p>
   */
  protected Map getKeyMethodMap() {
    Map<String, String> map = new HashMap<String, String>();
    map.put("button.Create", "createNewAdmin");
    map.put("button.Cancel", "cancel");
    return map;
  }

  /**
   * <p>Default action method.</p>
   *
   * @return ActionForward
   */
  public ActionForward defaultMethod(ActionMapping mapping,
                                     ActionForm form,
                                     HttpServletRequest request,
                                     HttpServletResponse response)
          throws Exception {
    logger.debug("defaultMethod");
    return loadCreateNewAdminPage(mapping, form, request, response);
  }

  public ActionForward loadCreateNewAdminPage(ActionMapping mapping,
                                           ActionForm form,
                                           HttpServletRequest request,
                                           HttpServletResponse response)
  {
    logger.debug("loadCreateNewAdminPage");
    // local variables
    CreateAdminBean createAdminBean = (CreateAdminBean) form;
    if (createAdminBean == null) createAdminBean = new CreateAdminBean();

    // Redirect to home view.
    return mapping.findForward("create.new.admin");
  }


  /**
   * <p>User selected cancel button.</p>
   *
   * @return ActionForward
   */
  public ActionForward cancel(ActionMapping mapping,
                              ActionForm form,
                              HttpServletRequest request,
                              HttpServletResponse response)
          throws Exception {
    logger.info("Cancel create new admin.");
    return mapping.findForward("admin.home");
  }

  public ActionForward createNewAdmin(ActionMapping mapping,
                                      ActionForm form,
                                      HttpServletRequest request,
                                      HttpServletResponse response)
          throws ClientException, Exception {
    logger.info("Create New Admin");
    CreateAdminBean user = (CreateAdminBean) form;
    logger.debug(user.toString());

    try {
      medRecClientServiceFacade.saveAdminUser(user.toUser());
    } catch (MedRecException ex) {
      // FIXME
      ex.printStackTrace();
      return mapping.findForward("create.new.admin");
    }
    logger.info("MedRec Administrator successfully created.");
    return mapping.findForward("create.new.admin.successful");
  }
}
