package com.bea.medrec.web.admin.actions;

import com.bea.medrec.domain.XmlImportFile;
import com.bea.medrec.exceptions.MedRecException;
import com.bea.medrec.web.admin.beans.XmlImportBean;
import com.bea.medrec.web.exceptions.ClientException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * <p>Controller that retrieves all pending XML medical records.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class ViewImportRecordsAction extends AdminBaseAction {

  /**
   * <p>Process the specified HTTP request, and create the corresponding HTTP
   * response (or forward to another web component that will create it).
   * Return an <code>ActionForward</code> instance describing where and how
   * control should be forwarded.
   * <br>
   * View pending incoming XML medical records..
   * </p>
   *
   * @param mapping  The ActionMapping used to select this instance
   * @param form  The optional ActionForm bean for this request (if any)
   * @param request  The HTTP request we are processing
   * @param response  The HTTP response we are creating
   */
  public ActionForward executeAction(ActionMapping mapping,
                                     ActionForm form,
                                     HttpServletRequest request,
                                     HttpServletResponse response)
      throws ClientException, Exception {
    Collection xmlFiles = null;
    Collection importBeans = null;

    try {
      // Get xml files to be uploaded.
      xmlFiles = medRecClientServiceFacade.getIncomingXmlFiles();
      importBeans = toImportBeanCollection(xmlFiles);
    } catch (MedRecException e) {
      throwClientException(e, mapping, "home");
    }
    // Set on request to be display by view.
    request.setAttribute(IMPORT_BEANS, importBeans);

    return mapping.findForward("view.import.files");
  }

  //   I M P O R T   C O L L E C T I O N
  /**
   * <p>Converts a collection of import value objects to
   * a collection of import presentation beans.</p>
   *
   * @param importFiles Collection of Import value objects
   * @return Collection   Collection of Import presentation beans
   */
  public Collection toImportBeanCollection(Collection importFiles) {
    Collection array = new ArrayList();
    if (importFiles != null) {
      Iterator itr = importFiles.iterator();
      while (itr.hasNext()) {
        XmlImportBean xmlImportBean =
            new XmlImportBean((XmlImportFile) itr.next());
        array.add(xmlImportBean);
      }
    }
    return array;
  }
}
