package com.bea.medrec.web.admin.actions;

import com.bea.medrec.domain.Patient;
import com.bea.medrec.exceptions.MedRecException;
import com.bea.medrec.web.beans.PatientBean;
import com.bea.medrec.web.exceptions.ClientException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * <p>Controller to view pending new patient registrations.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class ViewPatientRequestAction extends AdminBaseAction {

  /**
   * <p>Process the specified HTTP request, and create the corresponding HTTP
   * response (or forward to another web component that will create it).
   * Return an <code>ActionForward</code> instance describing where and how
   * control should be forwarded.
   * <br>
   * View pending patient registration information.
   * </p>
   *
   * @param mapping  The ActionMapping used to select this instance
   * @param form  The optional ActionForm bean for this request (if any)
   * @param request  The HTTP request we are processing
   * @param response  The HTTP response we are creating
   */
  public ActionForward executeAction(ActionMapping mapping,
                                     ActionForm form,
                                     HttpServletRequest request,
                                     HttpServletResponse response)
      throws ClientException, Exception {

    String patientId = request.getParameter("patientId");
    Patient patient = new Patient(new Integer(patientId));
    PatientBean patientBean = null;

    try {
      patient = medRecClientServiceFacade.getPatient(patient);
      patientBean = new PatientBean(patient);
      
      request.setAttribute (PATIENT_BEAN, patientBean);
      setSessionAttribute(request, PATIENT, patient);
    } catch (MedRecException e) {
      throwClientException(e, mapping, "home");
    }

    return mapping.findForward("view.patient.request");

  }
}