package com.bea.medrec.web.admin.beans;

import com.bea.medrec.domain.XmlImportFile;
import com.bea.medrec.web.utils.MedRecWebAppUtils;
import java.io.Serializable;

/**
 * <p>Bean to hold data about XML files</p>.
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public final class XmlImportBean implements Serializable {
  // Instance Variables
  private String filename = "";
  private String path = "";
  private String date = "";
  private String size = "";

  // Constructors
  public XmlImportBean() {
  }

  public XmlImportBean(XmlImportFile xmlImport) {
    this.filename = xmlImport.getFilename();
    this.path = xmlImport.getPath();
    this.date = MedRecWebAppUtils.getDisplayDate(xmlImport.getDate());
    this.size = xmlImport.getSize();
  }

  public XmlImportBean(String filename,
                       String path,
                       String date,
                       String size) {
    this.filename = filename;
    this.path = path;
    this.date = date;
    if (size != null) this.size = String.valueOf(size);
  }

  // Getters
  public String getFilename() {
    return (this.filename);
  }

  public String getPath() {
    return (this.path);
  }

  public String getDate() {
    return (this.date);
  }

  public String getSize() {
    return (this.size);
  }

  // Setters
  public void setFilename(String filename) {
    this.filename = filename;
  }

  public void setPath(String path) {
    this.path = path;
  }

  public void setDate(String date) {
    this.date = date;
  }

  public void setSize(String size) {
    this.size = size;
  }

  public String toString() {
    StringBuffer str = new StringBuffer();
    str.append("XmlImportBean [");
    str.append("Filename: "+this.filename);
    str.append(" | Path: "+this.path);
    str.append(" | Date: "+this.date);
    str.append(" | Size: "+this.size);
    str.append("]");

    return str.toString();
  }
}
