package com.bea.medrec.web.patient.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.bea.medrec.domain.Patient;
import com.bea.medrec.web.beans.PatientBean;

/**
 * <p>Controller to view patient profile.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class ViewProfileAction extends PatientBaseAction {

 /**
  * <p>Process the specified HTTP request, and create the corresponding HTTP
  * response (or forward to another web component that will create it).
  * Return an <code>ActionForward</code> instance describing where and how
  * control should be forwarded.
  * <br>
  * Redirects to profile view where values are retrieved from the session.
  * </p>
  *
  * @param mapping  The ActionMapping used to select this instance
  * @param form  The optional ActionForm bean for this request (if any)
  * @param request  The HTTP request we are processing
  * @param response  The HTTP response we are creating
  */
  public ActionForward executeAction(ActionMapping mapping,
                                     ActionForm form,
                                     HttpServletRequest request,
                                     HttpServletResponse response)
    throws Exception {
    
    Patient patient = (Patient)getSessionAttribute(request,
        PATIENT);    
    request.setAttribute (PATIENT_BEAN, new PatientBean (patient));
    
    return mapping.findForward("view.profile");
  }
}
