package com.bea.medrec.webservice;

import com.bea.medrec.service.MedRecServiceFacade;
import java.io.Serializable;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * <p>MedRecBaseWebServices provides base class services for all MedRec Web services.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class MedRecBaseWebServices implements Serializable {

  protected MedRecServiceFacade medRecServiceFacade;

  public void setMedRecServiceFacade(
      MedRecServiceFacade pMedRecServiceFacade) {
    this.medRecServiceFacade = pMedRecServiceFacade;
  }

  public MedRecServiceFacade getMedRecServiceFacade() {
    if (medRecServiceFacade != null)
      return medRecServiceFacade;

    ApplicationContext appContext =
        new ClassPathXmlApplicationContext(new String[]{
            "/applicationContext-db.xml",
            "/applicationContext-orm.xml",
            "/applicationContext-jms.xml",
            "/applicationContext-jmx.xml",
            "/applicationContext-mail.xml",
            "/applicationContext-service.xml",
            "/applicationContext-tx.xml"});
    medRecServiceFacade = (MedRecServiceFacade) appContext.getBean(
        "medRecServiceFacade");

    return this.medRecServiceFacade;
  }


  /**
   * Construct and throw javax.xml.rpc.soap.SOAPFaultException;
   */
  protected void captureException(MedRecWSResponse response,
                                  String exceptionClause){
    response.setExceptionClause(exceptionClause);
  }
}
