package com.bea.physician.domain;

/**
 * <p>This class represents information about a address.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public final class Address extends Entity {

  // Attributes
  private String street1;
  private String street2;
  private String city;
  private String state;
  private String zipCode;
  private String country;

  // Constructors
  public Address() {
  }

  public Address(Integer id,
                 String street1,
                 String street2,
                 String city,
                 String state,
                 String zipCode,
                 String country) {
    super.setId(id);
    this.street1 = street1;
    this.street2 = street2;
    this.city = city;
    this.state = state;
    this.zipCode = zipCode;
    this.country = country;
  }

  public Address(String id,
                 String street1,
                 String street2,
                 String city,
                 String state,
                 String zipCode,
                 String country) {
    super.setId(id);
    this.street1 = street1;
    this.street2 = street2;
    this.city = city;
    this.state = state;
    this.zipCode = zipCode;
    this.country = country;
  }

  // Getters
  public String getStreetName1() {
    return this.street1;
  }

  public String getStreetName2() {
    return this.street2;
  }

  public String getCity() {
    return this.city;
  }

  public String getState() {
    return this.state;
  }

  public String getZipCode() {
    return this.zipCode;
  }

  public String getCountry() {
    return this.country;
  }

  // Setters
  public void setStreetName1(String street1) {
    this.street1 = street1;
  }

  public void setStreetName2(String street2) {
    this.street2 = street2;
  }

  public void setCity(String city) {
    this.city = city;
  }

  public void setState(String state) {
    this.state = state;
  }

  public void setZipCode(String zipCode) {
    this.zipCode = zipCode;
  }

  public void setCountry(String country) {
    this.country = country;
  }

  // Utility
  public String toString() {
    StringBuffer str = new StringBuffer();
    str.append("Address[Id: "+super.getId());
    str.append(" | StreetName1: "+street1);
    str.append(" | StreetName2: "+street2);
    str.append(" | City: "+city);
    str.append(" | State: "+state);
    str.append(" | ZipCode: "+zipCode);
    str.append(" | Country: "+country);
    str.append("]");
    return str.toString();
  }
}
