package com.bea.physician.domain;

import java.io.Serializable;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.text.SimpleDateFormat;
import sun.misc.BASE64Encoder;

/**
 * <p>Base class for all value objects.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class Entity implements Serializable {

  // Attributes
  private Integer id;

  // Constructors
  public Entity() {
  }

  public Entity(Integer id) {
    this.id = id;
  }

  public Entity(int id) {
    this.id = new Integer(id);
  }

  // Getters
  public Integer getId() {
    return this.id;
  }

  // Setters
  public void setId(Integer id) {
    this.id = id;
  }

  public void setId(int id) {
    this.id = new Integer(id);
  }

  public void setId(String id) {
    this.id = str2Integer(id);
  }

  // Utility
  protected String getDisplayDate(java.util.Calendar pCalendar) {
    SimpleDateFormat format = new SimpleDateFormat("MM/dd/yyyy");
    if (pCalendar != null)
      return format.format(pCalendar.getTime());
    else
      return "";
  }

  protected String toStr(Object obj) {
    if (obj != null)
      return obj.toString();
    else
      return null;
  }

  protected Integer str2Integer(String str) {
    Integer tempInt = null;
    try {
      if (str != null)
        tempInt = Integer.valueOf(str);
    } catch (NumberFormatException e) {
    }
    return tempInt;
  }

  /**
   * <p>String null check.</p>
   *
   * @param str
   */
  public boolean isNotEmpty(String str) {
    return str != null && str.length() > 0;
  }

  /**
   * <p>Integer check.</p>
   *
   * @param intg
   */
  public boolean isNotEmpty(Integer intg) {
    return intg != null && intg != 0;
  }

  /**
   * <p>String null check.</p>
   *
   * @param str
   */
  public boolean isEmpty(String str) {
    return !(isNotEmpty(str));
  }

  /**
   * <p></p>
   *
   * @param passToConvert
   * @return
   */
  public String encodePassword(String passToConvert) {
    SecureRandom rnd = null;
    try {
      rnd = SecureRandom.getInstance("SHA1PRNG");
    } catch (NoSuchAlgorithmException nsae) {
      // If no SHA1 PRNG, try the old style.
      rnd = new SecureRandom(
          new Long(System.currentTimeMillis()).toString().getBytes());
    }
    String salt = "1234";
    byte[] someBytes = salt.getBytes();
    rnd.nextBytes(someBytes);
    salt = new BASE64Encoder().encode(someBytes);
    if (salt.length() > 4)
      salt = salt.substring(0, 4);

    String hashedValue = null;
    try {
      MessageDigest digest = MessageDigest.getInstance("sha-1");
      digest.update(salt.getBytes());
      digest.update(new String(passToConvert).getBytes());
      byte[] pwdHashFromUser = digest.digest();
      hashedValue = new BASE64Encoder().encode(pwdHashFromUser);
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    }

    String password = "{sha-1}" + salt + hashedValue;
    return password;
  }
}
