package com.bea.physician.domain;

import java.io.Serializable;
import java.util.List;

/**
 * <p>Encapsulates patient's medical record summary.
 * Includes Listof abbreviated records and
 * Listof current and recent prescriptions.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public final class RecordsSummary implements Serializable {

  private Record[] records;
  private Prescription[] prescriptions;

  public RecordsSummary() {
  }

  public RecordsSummary(Record[] records, Prescription[] prescriptions) {
    this.records = records;
    this.prescriptions = prescriptions;
  }

  public Record[] getRecords() {
    return this.records;
  }

  public Prescription[] getPrescriptions() {
    return this.prescriptions;
  }

  public void setRecords(Record[] records) {
    this.records = records;
  }

  public void setPrescriptions(Prescription[] prescriptions) {
    this.prescriptions = prescriptions;
  }

  // Utility methods
  public int recordsSize() {
    if (records == null)
      return 0;
    else
      return records.length;
  }

  public int prescriptionSize() {
    if (prescriptions == null)
      return 0;
    else
      return prescriptions.length;
  }

  public String toString() {
    return "RecordsSummary{"+
        "records="+ records+
        ", prescriptions="+ prescriptions+
        "}";
  }
}