package com.bea.physician.domain;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>Represents information about a user including
 * username and password.</p>
 *
 * @author Copyright (c) @COPYRIGHT_CURRENTYEAR by BEA Systems. All Rights Reserved.
 */
public class User extends Entity {
  private String username;
  private String password;
  private String status;
  private List groups = new ArrayList();

  // Constructors
  public User() {
  }

  public User(String pUsername) {
    this.username = pUsername;
  }

  public User(String pUsername,
              String pPassword,
              String pStatus) {
    this.username = pUsername;
    this.password = pPassword;
    this.status = pStatus;
  }

  public User(String pUsername,
              String pPassword,
              String pStatus,
              List pGroups) {
    this.username = pUsername;
    this.password = pPassword;
    this.status = pStatus;
    this.groups = pGroups;
  }

  // Getters
  public String getUsername() {
    return this.username;
  }

  public String getPassword() {
    return this.password;
  }

  public String getEncodedPassword() {
    return encodePassword(this.password);
  }

  public String getStatus() {
    return this.status;
  }
  
  public List getGroups() {
    return this.groups;
  }

  // Setters
  public void setUsername(String pUsername) {
    this.username = pUsername;
  }

  public void setPassword(String pPassword) {
    this.password = pPassword;
  }

  public void setStatus(String pStatus) {
    this.status = pStatus;
  }

  public void setGroups(List pGroups) {
    this.groups = pGroups;
  }

  public boolean isUserNotEmpty() {
    return (isNotEmpty(getStatus()) && isNotEmpty(getUsername())
        && isNotEmpty(getPassword()));
  }

  public String toString() {
    StringBuffer str = new StringBuffer();
    str.append("User[Username: "+username);
    str.append(" | Password: "+printPassword());
    str.append(" | Status: "+status);
    str.append(" | Groups: ");
    if (groups != null && groups.size() > 0) {
      for (int i=0; i<groups.size(); i++) {
        str.append(groups.get(i)+" ");
      }
    } else {
      str.append("0");
    }
    str.append("]");
    return str.toString();
  }

  // Utility
  private String printPassword() {
    String pwd = "";
    if (password != null) for (int i = 0; i < password.length(); i++) pwd += "*";
    return pwd;
  }
}