package com.bea.physician.service;

import java.util.*;

import com.bea.medrec.domain.Prescription;

/**
 * FIXME
 */
public class BaseService {

    /**
     * <p>
     * String null check.
     * </p>
     * 
     * @param str
     */
    protected boolean isNotEmpty(String str) {
        return str != null && str.length() > 0;
    }

    /**
     * <p>
     * Integer check.
     * </p>
     * 
     * @param intg
     */
    protected boolean isNotEmpty(Integer intg) {
        return intg != null && intg != 0;
    }

    /**
     * <p>
     * String null check.
     * </p>
     * 
     * @param str
     */
    protected boolean isEmpty(String str) {
        return !(isNotEmpty(str));
    }

    protected com.bea.physician.domain.Record toPhysicianRecord(com.bea.medrec.domain.Record pMedRecRecord) {
        if (pMedRecRecord == null)
            return new com.bea.physician.domain.Record();

        com.bea.physician.domain.Record physicianRecord = new com.bea.physician.domain.Record();
        physicianRecord.setId(pMedRecRecord.getId());
        physicianRecord.setPatientId(pMedRecRecord.getPatientId());
        physicianRecord.setDate(date2Cal(pMedRecRecord.getRecordDate()));
        physicianRecord.setSymptoms(pMedRecRecord.getSymptoms());
        physicianRecord.setDiagnosis(pMedRecRecord.getDiagnosis());
        physicianRecord.setNotes(pMedRecRecord.getNotes());

        com.bea.medrec.domain.VitalSigns medrecVitals = pMedRecRecord.getVitalSigns();
        if (medrecVitals != null) {
            com.bea.physician.domain.VitalSigns vitals = new com.bea.physician.domain.VitalSigns();
            vitals.setHeight(medrecVitals.getHeight());
            vitals.setWeight(medrecVitals.getWeight());
            vitals.setTemperature(medrecVitals.getTemperature());
            vitals.setBloodPressure(medrecVitals.getBloodPressure());
            vitals.setPulse(medrecVitals.getPulse());
            physicianRecord.setVitalSigns(vitals);
        }

        com.bea.medrec.domain.Physician medrecPhysician = pMedRecRecord.getPhysician();
        if (medrecPhysician != null) {
            com.bea.physician.domain.Physician physician = new com.bea.physician.domain.Physician();
            physician.setFirstName(medrecPhysician.getFirstName());
            physician.setMiddleName(medrecPhysician.getMiddleName());
            physician.setLastName(medrecPhysician.getLastName());
            physicianRecord.setPhysician(physician);
        }

        Prescription[] medrecPrescriptions = pMedRecRecord.getPrescriptions();
        physicianRecord.setPrescriptions(toPhysicianPrescriptions(medrecPrescriptions));

        return physicianRecord;
    }

    protected com.bea.physician.domain.Prescription[] toPhysicianPrescriptions(Collection pMedrecPrescriptions) {
        com.bea.physician.domain.Prescription[] physicianPrescriptions = null;
        if (pMedrecPrescriptions != null && pMedrecPrescriptions.size() > 0) {
            physicianPrescriptions = new com.bea.physician.domain.Prescription[pMedrecPrescriptions.size()];
            int i = 0;
            for (Iterator iterator = pMedrecPrescriptions.iterator(); iterator.hasNext();) {
                com.bea.medrec.domain.Prescription medrecPrescription = (com.bea.medrec.domain.Prescription) iterator.next();
                physicianPrescriptions[i] = new com.bea.physician.domain.Prescription();
                physicianPrescriptions[i].setId(medrecPrescription.getId());
                physicianPrescriptions[i].setRecordId(medrecPrescription.getRecordId());
                physicianPrescriptions[i].setPatientId(medrecPrescription.getPatientId());
                physicianPrescriptions[i].setDatePrescribed(date2Cal(medrecPrescription.getDatePrescribed()));
                physicianPrescriptions[i].setDrug(medrecPrescription.getDrug());
                physicianPrescriptions[i].setDosage(medrecPrescription.getDosage());
                physicianPrescriptions[i].setFrequency(medrecPrescription.getFrequency());
                physicianPrescriptions[i].setInstructions(medrecPrescription.getInstructions());
                physicianPrescriptions[i].setRefillsRemaining(medrecPrescription.getRefillsRemaining());
                i++;
            }
        } else {
            physicianPrescriptions = new com.bea.physician.domain.Prescription[0];
        }
        return physicianPrescriptions;
    }

    protected com.bea.physician.domain.Prescription[] toPhysicianPrescriptions(com.bea.medrec.domain.Prescription[] pMedrecPrescriptions) {

        com.bea.physician.domain.Prescription[] physicianPrescriptions = null;
        if (pMedrecPrescriptions != null && pMedrecPrescriptions.length > 0) {
            physicianPrescriptions = new com.bea.physician.domain.Prescription[pMedrecPrescriptions.length];

            for (int i = 0; i < pMedrecPrescriptions.length; i++) {
                com.bea.medrec.domain.Prescription medrecPrescription = pMedrecPrescriptions[i];
                physicianPrescriptions[i] = new com.bea.physician.domain.Prescription();
                physicianPrescriptions[i].setId(medrecPrescription.getId());
                physicianPrescriptions[i].setRecordId(medrecPrescription.getRecordId());
                physicianPrescriptions[i].setPatientId(medrecPrescription.getPatientId());
                physicianPrescriptions[i].setDatePrescribed(date2Cal(medrecPrescription.getDatePrescribed()));
                physicianPrescriptions[i].setDrug(medrecPrescription.getDrug());
                physicianPrescriptions[i].setDosage(medrecPrescription.getDosage());
                physicianPrescriptions[i].setFrequency(medrecPrescription.getFrequency());
                physicianPrescriptions[i].setInstructions(medrecPrescription.getInstructions());
                physicianPrescriptions[i].setRefillsRemaining(medrecPrescription.getRefillsRemaining());
            }
        } else {
            physicianPrescriptions = new com.bea.physician.domain.Prescription[0];
        }
        return physicianPrescriptions;
    }

    protected com.bea.physician.domain.RecordsSummary toPhysicianRecordsSummary(com.bea.medrec.domain.RecordsSummary pMedRecRecordsSummary) {
        com.bea.physician.domain.Record[] physicianRecords = null;
        com.bea.medrec.domain.Record[] medrecRecords = pMedRecRecordsSummary.getRecords();
        com.bea.physician.domain.Prescription[] physicianPrescriptions = toPhysicianPrescriptions(pMedRecRecordsSummary.getPrescriptions());
        if (medrecRecords != null && medrecRecords.length > 0) {
            physicianRecords = new com.bea.physician.domain.Record[medrecRecords.length];
            for (int i = 0; i < medrecRecords.length; i++) {
                physicianRecords[i] = toPhysicianRecord(medrecRecords[i]);
            }
        }
        return new com.bea.physician.domain.RecordsSummary(physicianRecords, physicianPrescriptions);
    }

    protected com.bea.physician.domain.Patient toPhysicianPatient(com.bea.medrec.domain.Patient pMedRecPatient) {
        com.bea.physician.domain.Patient physicianPatient = new com.bea.physician.domain.Patient();
        physicianPatient.setId(pMedRecPatient.getId());
        physicianPatient.setFirstName(pMedRecPatient.getFirstName());
        physicianPatient.setMiddleName(pMedRecPatient.getMiddleName());
        physicianPatient.setLastName(pMedRecPatient.getLastName());
        physicianPatient.setDateOfBirth(date2Cal(pMedRecPatient.getDob()));
        physicianPatient.setGender(pMedRecPatient.getGender());
        physicianPatient.setSsn(pMedRecPatient.getSsn());
        physicianPatient.setPhone(pMedRecPatient.getPhone());
        physicianPatient.setEmail(pMedRecPatient.getUser().getUsername());
        com.bea.medrec.domain.Address medrecAddress = pMedRecPatient.getAddress();
        if (medrecAddress != null) {
            com.bea.physician.domain.Address physicianAddress = new com.bea.physician.domain.Address();
            physicianAddress.setStreetName1(medrecAddress.getStreet1());
            physicianAddress.setStreetName2(medrecAddress.getStreet2());
            physicianAddress.setCity(medrecAddress.getCity());
            physicianAddress.setState(medrecAddress.getState());
            physicianAddress.setZipCode(medrecAddress.getZip());
            physicianAddress.setCountry(medrecAddress.getCountry());
            physicianPatient.setAddress(physicianAddress);
        }
        return physicianPatient;
    }

    protected com.bea.physician.domain.Patient[] toPhysicianPatients(com.bea.medrec.domain.Patient[] pMedRecPatient) {
        com.bea.physician.domain.Patient[] physicianPatients = null;
        if (pMedRecPatient != null && pMedRecPatient.length > 0) {
            physicianPatients = new com.bea.physician.domain.Patient[pMedRecPatient.length];
            for (int i = 0; i < pMedRecPatient.length; i++) {
                physicianPatients[i] = toPhysicianPatient(pMedRecPatient[i]);
            }
        } else {
            physicianPatients = new com.bea.physician.domain.Patient[0];
        }
        return physicianPatients;
    }

    protected com.bea.medrec.domain.Patient toMedRecPatient(com.bea.physician.domain.Patient pPhysicianPatient) {
        com.bea.medrec.domain.Patient medrecPatient = new com.bea.medrec.domain.Patient();
        // com.bea.medrec.domain.User medrecUser =
        // new com.bea.medrec.domain.User();
        //    
        medrecPatient.setId(pPhysicianPatient.getId());
        medrecPatient.setFirstName(pPhysicianPatient.getFirstName());
        medrecPatient.setMiddleName(pPhysicianPatient.getMiddleName());
        medrecPatient.setLastName(pPhysicianPatient.getLastName());
        medrecPatient.setDateOfBirth(pPhysicianPatient.getDateOfBirth() == null ? null : pPhysicianPatient.getDateOfBirth().getTime());
        medrecPatient.setGender(pPhysicianPatient.getGender());
        medrecPatient.setSsn(pPhysicianPatient.getSsn());
        medrecPatient.setPhone(pPhysicianPatient.getPhone());
        // medrecUser.setUsername(pPhysicianPatient.getEmail());
        // medrecUser.setPassword(pPhysicianPatient.getSsn());
        // medrecPatient.setUser(medrecUser);
        // medrecUser.setPatient(medrecPatient);
        //    
        com.bea.physician.domain.Address physicianAddress = pPhysicianPatient.getAddress();
        if (physicianAddress != null) {
            com.bea.medrec.domain.Address medrecAddress = new com.bea.medrec.domain.Address();
            medrecAddress.setStreet1(physicianAddress.getStreetName1());
            medrecAddress.setStreet2(physicianAddress.getStreetName2());
            medrecAddress.setCity(physicianAddress.getCity());
            medrecAddress.setState(physicianAddress.getState());
            medrecAddress.setZip(physicianAddress.getZipCode());
            medrecAddress.setCountry(physicianAddress.getCountry());
            medrecPatient.setAddress(medrecAddress);
        }
        return medrecPatient;
    }

    protected com.bea.medrec.domain.Record toMedRecRecord(com.bea.physician.domain.Record pPhysicianRecord) {
        com.bea.medrec.domain.Record medrecRecord = new com.bea.medrec.domain.Record();
        medrecRecord.setId(pPhysicianRecord.getId());
        medrecRecord.setPatientId(pPhysicianRecord.getPatientId());
        medrecRecord.setRecordDate(pPhysicianRecord.getDate().getTime());
        medrecRecord.setSymptoms(pPhysicianRecord.getSymptoms());
        medrecRecord.setDiagnosis(pPhysicianRecord.getDiagnosis());
        medrecRecord.setNotes(pPhysicianRecord.getNotes());

        com.bea.physician.domain.VitalSigns physicianVitals = pPhysicianRecord.getVitalSigns();
        if (physicianVitals != null) {
            com.bea.medrec.domain.VitalSigns vitals = new com.bea.medrec.domain.VitalSigns();
            vitals.setHeight(physicianVitals.getHeight());
            vitals.setWeight(physicianVitals.getWeight());
            vitals.setTemperature(physicianVitals.getTemperature());
            vitals.setBloodPressure(physicianVitals.getBloodPressure());
            vitals.setPulse(physicianVitals.getPulse());
            medrecRecord.setVitalSigns(vitals);
        }

        com.bea.physician.domain.Physician physicianPhysician = pPhysicianRecord.getPhysician();
        if (physicianPhysician != null) {
            com.bea.medrec.domain.Physician physician = new com.bea.medrec.domain.Physician();
            physician.setFirstName(physicianPhysician.getFirstName());
            physician.setMiddleName(physicianPhysician.getMiddleName());
            physician.setLastName(physicianPhysician.getLastName());
            medrecRecord.setPhysician(physician);
        }

        com.bea.physician.domain.Prescription[] physicianPrescriptions = pPhysicianRecord.getPrescriptions();
        medrecRecord.setPrescriptions(toMedRecPrescriptions(physicianPrescriptions));

        return medrecRecord;
    }

    protected com.bea.medrec.domain.Prescription[] toMedRecPrescriptions(com.bea.physician.domain.Prescription[] pPhysicianPrescriptions) {

        com.bea.medrec.domain.Prescription[] medrecPrescriptions = null;

        if (pPhysicianPrescriptions != null && pPhysicianPrescriptions.length > 0) {
            medrecPrescriptions = new com.bea.medrec.domain.Prescription[pPhysicianPrescriptions.length];

            for (int i = 0; i < pPhysicianPrescriptions.length; i++) {
                com.bea.medrec.domain.Prescription medrecPrescription = new com.bea.medrec.domain.Prescription();
                medrecPrescription.setId(pPhysicianPrescriptions[i].getId());
                medrecPrescription.setRecordId(pPhysicianPrescriptions[i].getRecordId());
                medrecPrescription.setPatientId(pPhysicianPrescriptions[i].getPatientId());
                medrecPrescription.setDatePrescribed(pPhysicianPrescriptions[i].getDatePrescribed().getTime());
                medrecPrescription.setDrug(pPhysicianPrescriptions[i].getDrug());
                medrecPrescription.setDosage(pPhysicianPrescriptions[i].getDosage());
                medrecPrescription.setFrequency(pPhysicianPrescriptions[i].getFrequency());
                medrecPrescription.setInstructions(pPhysicianPrescriptions[i].getInstructions());
                medrecPrescription.setRefillsRemaining(pPhysicianPrescriptions[i].getRefillsRemaining());
                medrecPrescriptions[i] = medrecPrescription;
            }
        } else {
            medrecPrescriptions = new com.bea.medrec.domain.Prescription[0];
        }

        return medrecPrescriptions;
    }

    protected Calendar date2Cal(java.util.Date pDate) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(pDate);
        return cal;
    }

}
